<?php

namespace Litecms\Forever;

use User;

class Forever
{
    /**
     * $forvever object.
     */
    protected $forvever;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Forever\Interfaces\ForveverRepositoryInterface $forvever)
    {
        $this->forvever = $forvever;
    }

    /**
     * Returns count of forever.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.forvever.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->forvever->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\ForveverUserCriteria());
        }

        $forvever = $this->forvever->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('forever::' . $view, compact('forvever'))->render();
    }
}
