<?php

namespace Litecms\Forever\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class ForveverTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Forever\Models\Forvever $forvever)
    {
        return [
            'id'                => $forvever->getRouteKey(),
            'key'               => [
                'public'    => $forvever->getPublicKey(),
                'route'     => $forvever->getRouteKey(),
            ], 
            'name'              => $forvever->name,
            'image'             => $forvever->image,
            'url'               => [
                'public'    => trans_url('forever/'.$forvever->getPublicKey()),
                'user'      => guard_url('forever/forvever/'.$forvever->getRouteKey()),
            ], 
            'status'            => trans('app.'.$forvever->status),
            'created_at'        => format_date($forvever->created_at),
            'updated_at'        => format_date($forvever->updated_at),
        ];
    }
}